REM $INCLUDE: 'qbx.bi'

DIM Register AS RegType

' Interrupt &H11: Feststellen der Konfiguration
Interrupt &H11, Register, Register

PRINT "Anzahl der Diskettenlaufwerke:";
IF Register.AX AND 1 THEN
	' System besitzt Diskettenlaufwerke, Anzahl steht in
	' den Bits 7-8 von AX (0 bedeutet 1 LW, 1 bedeutet 2 etc.)
	PRINT TeilZahl(Register.AX, 7, 8) + 1
ELSE
	' System besitzt keine Diskettenlaufwerke
	PRINT "0"
END IF

' Bei Coprozessor ist Bit 2 von AX gesetzt
PRINT "Coprozessor: ";
IF Register.AX AND 2 THEN
	PRINT "installiert"
ELSE
	PRINT "nicht installiert"
END IF

' Bits 10-12 von AX enthalten die Anzahl
' der COM-Schnittstellen
PRINT "Serielle Schnittstellen:";
PRINT TeilZahl(Register.AX, 10, 12)

' Bits 15-16 enthalten die Anzahl der
' LPT-Schnittstellen
PRINT "Drucker-Schnittstellen:";
PRINT TeilZahl(Register.AX, 15, 16)

' Interrupt &H12: Feststellen der Speichergre
Interrupt &H12, Register, Register
PRINT "Speicher unter 1 MB:";
PRINT Register.AX; "KB"

