DECLARE FUNCTION FreierPlatz& (Laufwerk AS STRING)
DECLARE FUNCTION UnsignedInt& (Zahl AS INTEGER)
REM $INCLUDE: 'qbx.bi'

FUNCTION FreierPlatz& (Laufwerk AS STRING)

	DIM Reg AS RegType
	Reg.AX = &H3600
	IF Laufwerk = "" THEN
		Reg.DX = 0
	ELSE
		Reg.DX = ASC(UCASE$(Laufwerk)) - 64
	END IF
	Interrupt &H21, Reg, Reg
	IF Reg.AX = -1 THEN
		FreierPlatz = -1
	ELSE
		FreierPlatz = UnsignedInt(Reg.AX) * UnsignedInt(Reg.BX) * UnsignedInt(Reg.CX)
	END IF

END FUNCTION

FUNCTION UnsignedInt& (Zahl AS INTEGER)

	' konvertiert eine BASIC-Integer-Zahl (von -32768 bis
	' 32767) in einen unsigned Integer, wie er von DOS-
	' Interrupts meist zurckgegeben wird (0 bis 65535).
	' Das Ergebnis mu in BASIC als LONG-Zahl dargestellt
	' werden. 

	IF Zahl < 0 THEN
		UnsignedInt = CLNG(Zahl) + 65536
		' CLNG notwendig, da sonst Overflow-Fehler auftritt,
		' weil Ergebnis einer INTEGER-Berechnung grer 32767
	ELSE
		UnsignedInt = Zahl
	END IF

END FUNCTION

