DECLARE FUNCTION ShellPar% (Programmname AS STRING, Parameter AS STRING)
REM $INCLUDE: 'qbx.bi'

FUNCTION ShellPar% (Programmname AS STRING, Parameter AS STRING)

	DIM Regs AS RegTypeX

	IF Parameter <> "" THEN
		NewCommand$ = CHR$(LEN(Parameter) + 1) + " " + Parameter + CHR$(13)
	ELSE
		NewCommand$ = CHR$(0) + CHR$(13)
	END IF
	Parameter$ = MKI$(0) + MKL$(SSEGADD(NewCommand$)) + STRING$(8, 0)
	Dateiname$ = Programmname + CHR$(0)

	Regs.AX = &H4B00
	Regs.ES = SSEG(Parameter$)
	Regs.BX = SADD(Parameter$)
	Regs.DS = SSEG(Dateiname$)
	Regs.DX = SADD(Dateiname$)

	InterruptX &H21, Regs, Regs

	IF Regs.Flags AND 1 THEN
		SELECT CASE Regs.AX
		CASE 2: ERROR 53     ' Datei nicht gefunden
		CASE 5: ERROR 70     ' Zugriff verweigert
		CASE 8: ERROR 7      ' Speicher reicht nicht
		CASE ELSE: ERROR 5   ' anderer Fehler
		END SELECT
	END IF

	Regs.AX = &H4D00
	InterruptX &H21, Regs, Regs

	IF Regs.AX AND &HFF00 THEN
		' Wenn in AH etwas steht, wird diese Zahl mit negativem
		' Vorzeichen als Code zurckgegeben. Es bedeuten:
		' -1: Programm mit Ctrl-C oder Ctrl-Break abgebrochen
		' -2: Programm abgeborchen wegen Gertefehler (z.B. Disk not
		'     ready)
		' -3: Programm hat sich speicherresident gemacht
		ShellPar% = -(Regs.AX \ 256)
	ELSE
		' Anderenfalls wird der Return-Code, den das Programm selbst
		' gesetzt hat und der in AL steht, als positiver Wert zurck-
		' gegeben (die meisten Programme geben 0 zurck, wenn alles
		' o.k. war, und einen anderen Code, wenn es Fehler gab).
		ShellPar% = Regs.AX MOD 256
	END IF
			
END FUNCTION

